/* SPDX-License-Identifier: LGPL-2.1-or-later */
/*
 * Copyright (C) 2019, Google Inc.
 *
 * control_ids.cpp : Control ID list
 *
 * This file is auto-generated. Do not edit.
 */

#include <libcamera/control_ids.h>

/**
 * \file control_ids.h
 * \brief Camera control identifiers
 */

namespace libcamera {

/**
 * \brief Namespace for libcamera controls
 */
namespace controls {

/**
 * \var AeEnable
 * \brief Enable or disable the AE.
 *
 * \sa ManualExposure
 */

/**
 * \var AeLocked
 * \brief Report the lock status of a running AE algorithm.
 *
 * If the AE algorithm is locked the value shall be set to true, if it's
 * converging it shall be set to false. If the AE algorithm is not
 * running the control shall not be present in the metadata control list.
 *
 * \sa AeEnable
 */

/**
 * \var AwbEnable
 * \brief Enable or disable the AWB.
 *
 * \sa ManualGain
 */

/**
 * \var Brightness
 * \brief Specify a fixed brightness parameter
 */

/**
 * \var Contrast
 * \brief Specify a fixed contrast parameter
 */

/**
 * \var Saturation
 * \brief Specify a fixed saturation parameter
 */

/**
 * \var ManualExposure
 * \brief Specify a fixed exposure time in milli-seconds
 */

/**
 * \var ManualGain
 * \brief Specify a fixed gain parameter
 */

#ifndef __DOXYGEN__
/*
 * Keep the controls definitions hidden from doxygen as it incorrectly parses
 * them as functions.
 */
extern const Control<bool> AeEnable(AE_ENABLE, "AeEnable");
extern const Control<bool> AeLocked(AE_LOCKED, "AeLocked");
extern const Control<bool> AwbEnable(AWB_ENABLE, "AwbEnable");
extern const Control<int32_t> Brightness(BRIGHTNESS, "Brightness");
extern const Control<int32_t> Contrast(CONTRAST, "Contrast");
extern const Control<int32_t> Saturation(SATURATION, "Saturation");
extern const Control<int32_t> ManualExposure(MANUAL_EXPOSURE, "ManualExposure");
extern const Control<int32_t> ManualGain(MANUAL_GAIN, "ManualGain");
#endif

/**
 * \brief List of all supported libcamera controls
 */
extern const ControlIdMap controls {
	{ AE_ENABLE, &AeEnable },
	{ AE_LOCKED, &AeLocked },
	{ AWB_ENABLE, &AwbEnable },
	{ BRIGHTNESS, &Brightness },
	{ CONTRAST, &Contrast },
	{ SATURATION, &Saturation },
	{ MANUAL_EXPOSURE, &ManualExposure },
	{ MANUAL_GAIN, &ManualGain },
};

} /* namespace controls */

} /* namespace libcamera */
